package hideandseek.managers;

import org.bukkit.entity.Player;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

public class ClickableTextManager
{
    private final Method fromLegacyText;
    private Constructor<?> textComponentConstructor;
    private final Constructor<?> clickEvent;
    private final Class<Enum> actionEnum;
    private final Enum<?> RUN_COMMAND;
    private final Method setClickEvent;
    private final Method sendMessage;
    
    public ClickableTextManager() throws NoSuchMethodException, SecurityException, ClassNotFoundException {
        final Class var1 = Class.forName("net.md_5.bungee.api.chat.TextComponent");
        this.fromLegacyText = var1.getMethod("fromLegacyText", String.class);
        final Object[] var2 = this.getBaseComponent("Test");
        final Constructor[] var3 = var1.getConstructors();
        final int var4 = var3.length;
        int var5 = 0;
        while (var5 < var4) {
            final Constructor var6 = var3[var5];
            try {
                var6.newInstance(var2);
                this.textComponentConstructor = var6;
                break;
            }
            catch (final Exception var7) {
                ++var5;
            }
        }
        if (this.textComponentConstructor == null) {
            throw new NoSuchMethodException();
        }
        final Class var8 = Class.forName("net.md_5.bungee.api.chat.ClickEvent");
        this.actionEnum = (Class<Enum>)this.getNestedClass(var8, "Action");
        this.RUN_COMMAND = Enum.valueOf((Class<Enum<?>>)this.actionEnum, "RUN_COMMAND");
        this.clickEvent = var8.getConstructor(this.actionEnum, String.class);
        this.setClickEvent = var1.getMethod("setClickEvent", Class.forName("net.md_5.bungee.api.chat.ClickEvent"));
        this.sendMessage = this.getNestedClass(Class.forName("org.bukkit.entity.Player"), "Spigot").getMethod("sendMessage", Class.forName("net.md_5.bungee.api.chat.BaseComponent"));
    }
    
    private Class<?> getNestedClass(final Class<?> var1, final String var2) {
        for (final Class var6 : var1.getClasses()) {
            if (var6.getSimpleName().equals(var2)) {
                return var6;
            }
        }
        return null;
    }
    
    private Object[] getBaseComponent(final String var1) {
        Object[] var2;
        try {
            var2 = (Object[])this.fromLegacyText.invoke(null, var1);
        }
        catch (final IllegalAccessException | InvocationTargetException e) {
            var2 = null;
            e.printStackTrace();
        }
        return var2;
    }
    
    private Object getTextComponent(final String var1, final String var2) {
        final Object[] var3 = this.getBaseComponent(var1);
        Object var4;
        try {
            var4 = this.textComponentConstructor.newInstance(var3);
            this.setClickEvent.invoke(var4, this.clickEvent.newInstance(this.RUN_COMMAND, "/" + var2));
        }
        catch (final InstantiationException | IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
            var4 = null;
            e.printStackTrace();
        }
        return var4;
    }
    
    private Object getSpigot(final Player var1) {
        Object object;
        try {
            object = Player.class.getMethod("spigot", (Class<?>[])new Class[0]).invoke(var1, new Object[0]);
        }
        catch (final IllegalAccessException | InvocationTargetException | NoSuchMethodException | SecurityException e) {
            object = null;
            e.printStackTrace();
        }
        return object;
    }
    
    public void sendMessage(final Player player, final String var2, final String var3) {
        try {
            this.sendMessage.invoke(this.getSpigot(player), this.getTextComponent(var2, var3));
        }
        catch (final IllegalArgumentException | InvocationTargetException | SecurityException | IllegalAccessException var4) {
            var4.printStackTrace();
        }
    }
}
